Sign in

Get started - Get started with Liveblocks, Monaco, Yjs, and JavaScript

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your JavaScript application using the APIs from the @liveblocks/yjs package.

Quickstart

  1. Install Liveblocks, Yjs, and Monaco

    Every Liveblocks package should use the same version.

    $npm install @liveblocks/client @liveblocks/yjs yjs monaco-editor y-monaco
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    $npx create-liveblocks-app@latest --init --framework javascript
  3. Create an HTML element

    <div id="editor"></div>
  4. Set up your collaborative Monaco code editor

    app.js
    import { createClient } from "@liveblocks/client";import { getYjsProviderForRoom } from "@liveblocks/yjs";import * as Y from "yjs";import * as monaco from "monaco-editor";import { MonacoBinding } from "y-monaco";
    // Set up Liveblocks clientconst client = createClient({ publicApiKey: "",});
    // Enter a multiplayer roomconst { room, leave } = client.enterRoom("my-room");
    // Set up Yjs document, shared text, and Liveblocks Yjs providerconst yProvider = getYjsProviderForRoom(room);const yDoc = yProvider.getYDoc();const yText = yDoc.getText("monaco");
    // Set up the Monaco editorconst parent = document.querySelector("#editor");const editor = monaco.editor.create(parent, { value: "", language: "javascript"})
    // Attach Yjs to Monacoconst monacoBinding = new MonacoBinding( yText, editorRef.getModel(), new Set([editor]), yProvider.awareness);
  5. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative Monaco code editor inside your JavaScript application.

We use cookies to collect data to improve your experience on our site. Read our Privacy Policy to learn more.

Sign in

Get started - Get started with Liveblocks, Monaco, Yjs, and Vue.js

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your Vue.js application using the APIs from the @liveblocks/yjs package.

Quickstart

  1. Install Liveblocks, Yjs, and Monaco

    Every Liveblocks package should use the same version.

    $npm install @liveblocks/client @liveblocks/yjs yjs monaco-editor y-monaco
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    $npx create-liveblocks-app@latest --init --framework javascript
  3. Set up your collaborative Monaco code editor

    Editor.vue
    <script setup>import { ref, onMounted, onUnmounted } from "vue";import { createClient } from "@liveblocks/client";import { getYjsProviderForRoom } from "@liveblocks/yjs";import * as Y from "yjs";import * as monaco from "monaco-editor";import { MonacoBinding } from "y-monaco";
    const element = ref(null);const editor = ref(null);const binding = ref(null);const leave = ref(null);
    // Set up Liveblocks clientconst client = createClient({ publicApiKey: "",});
    // Enter a multiplayer roomconst info = client.enterRoom("my-room");const room = info.room;leave.value = info.leave;
    // Set up Yjs document, shared text, and Liveblocks Yjs providerconst yProvider = getYjsProviderForRoom(room);const yDoc = yProvider.getYDoc();const yText = yDoc.getText("monaco");
    onMounted(() => { // Set up the Monaco editor editor.value = monaco.editor.create(element.value, { value: "", language: "javascript" })
    // Attach Yjs to Monaco binding.value = new MonacoBinding( yText, editorRef.getModel(), new Set([editor]), yProvider.awareness );});
    onUnmounted(() => { binding?.destroy(); editor?.dispose(); leave?.();});</script>
    <template> <div ref="element" /></template>
  4. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative Monaco code editor inside your Vue.js application.

We use cookies to collect data to improve your experience on our site. Read our Privacy Policy to learn more.

Sign in

Get started - Get started with Liveblocks, Yjs, Monaco, and React

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your React application using the APIs from the @liveblocks/yjs package.

Quickstart

  1. Install Liveblocks, Yjs, and Monaco

    Every Liveblocks package should use the same version.

    $npm install @liveblocks/client @liveblocks/react @liveblocks/yjs yjs @monaco-editor/react y-monaco y-protocols
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    $npx create-liveblocks-app@latest --init --framework react
  3. Set up the Liveblocks client

    Liveblocks uses the concept of rooms, separate virtual spaces where people collaborate, and to create a realtime experience, multiple users must be connected to the same room. Set up a Liveblocks client with LiveblocksProvider, and join a room with RoomProvider.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider,} from "@liveblocks/react/suspense";import { Editor } from "./Editor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> {/* ... */} </RoomProvider> </LiveblocksProvider> );}
  4. Join a Liveblocks room

    After setting up the room, you can add collaborative components inside it, using ClientSideSuspense to add loading spinners to your app.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider, ClientSideSuspense,} from "@liveblocks/react/suspense";import { CollaborativeEditor } from "./CollaborativeEditor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> <ClientSideSuspense fallback={<div>Loading…</div>}> <CollaborativeEditor /> </ClientSideSuspense> </RoomProvider> </LiveblocksProvider> );}
  5. Set up the collaborative Monaco code editor

    Now that we set up Liveblocks, we can start integrating Monaco and Yjs in the Editor.tsx file. To make the editor collaborative, we can rely on MonacoBinding from y-monaco.

    CollaborativeEditor.tsx
    "use client";
    import * as Y from "yjs";import { getYjsProviderForRoom } from "@liveblocks/yjs";import { useRoom } from "@/liveblocks.config";import { useCallback, useEffect, useState } from "react";import { Editor } from "@monaco-editor/react";import { editor } from "monaco-editor";import { MonacoBinding } from "y-monaco";import { Awareness } from "y-protocols/awareness";
    // Collaborative text editor with simple rich text, live cursors, and live avatarsexport function CollaborativeEditor() { const [editorRef, setEditorRef] = useState<editor.IStandaloneCodeEditor>(); const room = useRoom(); const yProvider = getYjsProviderForRoom(room);
    // Set up Liveblocks Yjs provider and attach Monaco editor useEffect(() => { let binding: MonacoBinding;
    if (editorRef) { const yDoc = yProvider.getYDoc(); const yText = yDoc.getText("monaco");
    // Attach Yjs to Monaco binding = new MonacoBinding( yText, editorRef.getModel() as editor.ITextModel, new Set([editorRef]), yProvider.awareness as Awareness ); }
    return () => { binding?.destroy(); }; }, [editorRef, room]);
    const handleOnMount = useCallback((e: editor.IStandaloneCodeEditor) => { setEditorRef(e); }, []);
    return ( <Editor onMount={handleOnMount} height="100vh" width="100hw" theme="vs-light" defaultLanguage="typescript" defaultValue="" options={{ tabSize: 2, }} /> );}
  6. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative Monaco code editor inside your React application.


Examples using Monaco

We use cookies to collect data to improve your experience on our site. Read our Privacy Policy to learn more.